﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace WpfListViewSelect
{
	/// <summary>
	/// MainWindow.xaml の相互作用ロジック
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			var data = new MainWindowViewModel();

			// Content を二つ作成
			var one = new Content() { Title = "One" };
			var two = new Content() { Title = "Two" };

			// 問題の発生するリスト
			data.ProblemContents.Add( one );
			data.ProblemContents.Add( two );
			data.ProblemContents.Add( one );
			data.ProblemContents.Add( two );

			// 問題の発生しないリスト
			data.Contents.Add( new ContentWrapper( one ) );
			data.Contents.Add( new ContentWrapper( two ) );
			data.Contents.Add( new ContentWrapper( one ) );
			data.Contents.Add( new ContentWrapper( two ) );

			this.DataContext = data;
			this.InitializeComponent();
		}
	}

	/// <summary>
	/// MainWindow の Model と View を仲介するクラスです。
	/// </summary>
	class MainWindowViewModel
	{
		public MainWindowViewModel()
		{
			this.Contents = new ObservableCollection< ContentWrapper >();
			this.ProblemContents = new ObservableCollection< Content >();
		}

		public ObservableCollection< ContentWrapper > Contents { get; private set; }

		public ObservableCollection< Content > ProblemContents { get; private set; }
		
	}
}
